## net.sf.saxon.functions
Class Existence

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.Existence

All Implemented Interfaces:
  java.io.Serializable, javax.xml.transform.SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, Negatable, SequenceIterable, InstructionInfo, org.xml.sax.Locator

    public class Existence

extends SystemFunction
implements Negatable

Implement the exists() and empty() functions

See Also:
  Serialized Form

Field Summary
`static int` `EMPTY`
`static int` `EXISTS`

Fields inherited from class net.sf.saxon.functions.SystemFunction
`operation`

Fields inherited from class net.sf.saxon.expr.FunctionCall
`argument`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, staticProperties`

Constructor Summary
`Existence()`

Method Summary
`void` `checkArguments(ExpressionVisitor visitor)` Static analysis: prevent sorting of the argument
`boolean` `effectiveBooleanValue(XPathContext c)` Evaluate the function in a boolean context
`Item` `evaluateItem(XPathContext c)` Evaluate in a general context
`boolean` `isNegatable(ExpressionVisitor visitor)` Check whether this specific instance of the expression is negatable
`Expression` `negate()` Return the negation of the expression
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`addContextDocumentArgument, addDocToPathMap, computeCardinality, computeSpecialProperties, copy, getDetails, getErrorCodeForTypeErrors, getItemType, getRequiredType, makeSystemFunction, setDetails, useContextItemAsDefault`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`addExternalFunctionCallToPathMap, checkArgumentCount, equals, explain, getArguments, getDisplayName, getFunctionName, getNumberOfArguments, hashCode, iterateSubExpressions, preEvaluate, promote, replaceSubExpression, setArguments, setFunctionName, simplify, simplifyArguments, toString, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression

`addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, display, doPromotion, dynamicError, evaluateAsString, evaluatePendingUpdates, explain, findParentOf, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isUpdatingExpression, iterate, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### EXISTS

    public static final int EXISTS

See Also:
  Constant Field Values

### EMPTY

    public static final int EMPTY

See Also:
  Constant Field Values

Constructor Detail

### Existence

    public Existence()

Method Detail

### checkArguments

    public void checkArguments(ExpressionVisitor visitor)
                        throws XPathException

  Static analysis: prevent sorting of the argument

  Overrides:
    `checkArguments` in class `SystemFunction`
  Parameters:
    `visitor` - the expression visitor
  Throws:
    `XPathException`

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `SystemFunction`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### isNegatable

    public boolean isNegatable(ExpressionVisitor visitor)

  Check whether this specific instance of the expression is negatable

  Specified by:
    `isNegatable` in interface `Negatable`
  Returns:
    true if it is

### negate

    public Expression negate()

  Return the negation of the expression

  Specified by:
    `negate` in interface `Negatable`
  Returns:
    the negation of the expression

### effectiveBooleanValue

    public boolean effectiveBooleanValue(XPathContext c)
                                  throws XPathException

  Evaluate the function in a boolean context

  Overrides:
    `effectiveBooleanValue` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the effective boolean value
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext c)
                      throws XPathException

  Evaluate in a general context

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

Copyright (c) Saxonica Limited. All rights reserved.